import { TickHandler, ResizeHandler, InteractionEvent, InteractionHandler } from 'sketch-application';
export { InteractionEvent, InteractionHandler, ResizeEvent, ResizeHandler, TickEvent, TickHandler } from 'sketch-application';
export { Application } from 'sketch-loop';

type InteractionActionParams = Parameters<InteractionHandler>[0];
interface InteractionParams extends InteractionActionParams {
    type: InteractionEvent['type'];
}
type InteractionAction = (arg: InteractionParams) => void;
type Props = {
    onTick: TickHandler;
    onResize?: ResizeHandler;
    onInteraction?: InteractionAction;
};
declare function SketchLoop({ onTick, onResize, onInteraction }: Props): JSX.Element;

export { InteractionAction, Props, SketchLoop };
