"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  SketchLoop: () => SketchLoop
});
module.exports = __toCommonJS(src_exports);
var import_react = require("react");
var import_sketch_loop = require("sketch-loop");
var import_jsx_runtime = require("react/jsx-runtime");
function SketchLoop({ onTick, onResize, onInteraction }) {
  const ref = (0, import_react.useRef)(null);
  (0, import_react.useEffect)(() => {
    if (ref == null || ref.current == null) {
      return;
    }
    const app = (0, import_sketch_loop.loop)({
      canvas: ref.current
    });
    app.on({
      type: "tick",
      action: onTick
    });
    if (onResize != null) {
      app.on({
        type: "resize",
        action: onResize
      });
    }
    if (onInteraction != null) {
      let createInteractionEvent2 = function(type) {
        return function onInteractionEvent(args) {
          if (onInteraction != null) {
            onInteraction({
              type,
              ...args
            });
          }
        };
      };
      var createInteractionEvent = createInteractionEvent2;
      app.on({
        type: "pointerdown",
        action: createInteractionEvent2("pointerdown")
      });
      app.on({
        type: "pointermove",
        action: createInteractionEvent2("pointermove")
      });
      app.on({
        type: "pointerup",
        action: createInteractionEvent2("pointerup")
      });
    }
    app.start();
    return () => {
      app.dispose();
    };
  }, [ref, onTick, onInteraction, onResize]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("canvas", { ref });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SketchLoop
});
